SystemOrganization addCategory: #'MC2-SqueakUI-Tests'!
SystemOrganization addCategory: #'MC2-SqueakUI-Browsers'!
SystemOrganization addCategory: #'MC2-SqueakUI-Nodes'!
SystemOrganization addCategory: #'MC2-SqueakUI-Commands'!

OBCommand subclass: #MDCmdSaveSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:44'!
execute
	target save! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:52'!
group
	^ #saving! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:01'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:37'!
keystroke
	^ $s! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:00'!
label
	^ 'save'! !

OBCommand subclass: #MDCmdSaveSliceToFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdSaveSliceToFile methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 01:02'!
execute
	| filename |
	filename _ OBTextRequest prompt: 'Filename?'.
	filename ifNotNil: [MDFileRepository saveSlice: target slice as: filename]! !

!MDCmdSaveSliceToFile methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:52'!
group
	^ #saving! !

!MDCmdSaveSliceToFile methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:48'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdSaveSliceToFile methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:45'!
label
	^ 'save slice to file...'! !

OBBrowser subclass: #MDSliceListBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDSliceListBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:17'!
defaultMetaNode
	| organizer slice |
	organizer _ OBMetaNode named: 'organizer'.
	slice _ OBMetaNode named: 'slice'.
	organizer childAt: #slices put: slice.
	^ organizer! !

!MDSliceListBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:14'!
defaultRootNode
	^ MDSliceOrganizerNode on: MDSliceOrganizer default! !

!MDSliceListBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:26'!
paneCount
	^ 1! !

!MDSliceListBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:28'!
panels
	^ Array with: self navigationPanel! !

!MDSliceListBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:34'!
title
	^ 'Slices'! !

!MDSliceListBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:00'!
cmdSaveSlice
	^ MDCmdSaveSlice! !

!MDSliceListBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:51'!
cmdSaveSliceToFile
	^ MDCmdSaveSliceToFile! !

!MDSliceListBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:35'!
initialExtent
	^ 200@400! !

OBCommandTest subclass: #MDCmdSaveSliceTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:36'!
factory
	^ MDCmdSaveSlice! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:42'!
isSelected: aNode
	^ isSelected! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:39'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $s! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:41'!
test04ConditionAcceptsSlice
	| node |
	node _ MDSliceNode on: (MDExplicitSlice new).
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:43'!
test05ConditionIgnoresParent
	| node |
	node _ MDSliceNode on: (MDExplicitSlice new).
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdSaveSliceToFileTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdSaveSliceToFileTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:45'!
factory
	^ MDCmdSaveSliceToFile! !

!MDCmdSaveSliceToFileTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:50'!
isSelected: aNode
	^ isSelected! !

!MDCmdSaveSliceToFileTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:46'!
test04ConditionAcceptsSlice
	| node |
	node _ MDSliceNode on: (MDExplicitSlice new).
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdSaveSliceToFileTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:47'!
test05ConditionIgnoresParent
	| node |
	node _ MDSliceNode on: (MDExplicitSlice new).
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBNode subclass: #MDNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:38'!
isSlice
	^ false! !

MDNode subclass: #MDSliceNode
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDSliceNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:18'!
on: aSlice
	^ self new setSlice: aSlice! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:38'!
isSlice
	^ true! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:21'!
name
	^ slice name! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:46'!
save
	slice save! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:18'!
setSlice: aSlice
	slice _ aSlice! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 01:01'!
slice
	^ slice! !

MDNode subclass: #MDSliceOrganizerNode
	instanceVariableNames: 'organizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDSliceOrganizerNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:15'!
on: anOrganizer
	^ self new setOrganizer: anOrganizer! !

!MDSliceOrganizerNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:15'!
setOrganizer: anOrganizer
	organizer _ anOrganizer! !

!MDSliceOrganizerNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:43'!
slices
	^ (organizer slices collect: [:ea | MDSliceNode on: ea])
		asArray sort: [:a :b | a name <= b name]! !
